# Generated by Django 3.0.2 on 2020-01-30 12:49

import django.contrib.postgres.fields.citext
from django.contrib.postgres.operations import CITextExtension
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        CITextExtension(),
        migrations.CreateModel(
            name='Company',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('abbreviation', django.contrib.postgres.fields.citext.CICharField(blank=True, max_length=10, null=True)),
                ('name', django.contrib.postgres.fields.citext.CICharField(max_length=256)),
                ('is_active', models.BooleanField(blank=True, default=False)),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='companies/companies/')),
            ],
            options={
                'verbose_name_plural': 'companies',
            },
        ),
        migrations.CreateModel(
            name='CompanyGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('abbreviation', django.contrib.postgres.fields.citext.CICharField(blank=True, max_length=10, null=True)),
                ('name', django.contrib.postgres.fields.citext.CICharField(max_length=256)),
                ('is_active', models.BooleanField(blank=True, default=False)),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='companies/groups/')),
            ],
            options={
                'verbose_name': 'group',
                'verbose_name_plural': 'groups',
            },
        ),
        migrations.CreateModel(
            name='Subsidiary',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('abbreviation', django.contrib.postgres.fields.citext.CICharField(blank=True, max_length=10, null=True)),
                ('name', django.contrib.postgres.fields.citext.CICharField(max_length=256)),
                ('is_active', models.BooleanField(blank=True, default=False)),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='companies/subsidiaries')),
                ('company', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='companies.Company')),
            ],
            options={
                'verbose_name_plural': 'subsidiaries',
            },
        ),
        migrations.CreateModel(
            name='Service',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('abbreviation', django.contrib.postgres.fields.citext.CICharField(blank=True, max_length=10, null=True)),
                ('name', django.contrib.postgres.fields.citext.CICharField(max_length=256)),
                ('is_active', models.BooleanField(blank=True, default=False)),
                ('last_update', models.DateTimeField(auto_now=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('logo', models.ImageField(blank=True, null=True, upload_to='companies/services')),
                ('subsidiary', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='companies.Subsidiary')),
            ],
        ),
        migrations.AddConstraint(
            model_name='companygroup',
            constraint=models.UniqueConstraint(fields=('name',), name='Two groups cannot share the same name, case insensitive'),
        ),
        migrations.AddConstraint(
            model_name='companygroup',
            constraint=models.UniqueConstraint(fields=('abbreviation',), name='Two groups cannot share the same abbreviation, case insensitive'),
        ),
        migrations.AddField(
            model_name='company',
            name='company_group',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to='companies.CompanyGroup'),
        ),
        migrations.AddConstraint(
            model_name='subsidiary',
            constraint=models.UniqueConstraint(fields=('company', 'name'), name='Two subsidiaries cannot share the same name and company.'),
        ),
        migrations.AddConstraint(
            model_name='subsidiary',
            constraint=models.UniqueConstraint(fields=('company', 'abbreviation'), name='Two subsidiaries cannot share the same abbreviation and company'),
        ),
        migrations.AddConstraint(
            model_name='service',
            constraint=models.UniqueConstraint(fields=('subsidiary', 'name'), name='Two services cannot share the same name and subsidiary'),
        ),
        migrations.AddConstraint(
            model_name='service',
            constraint=models.UniqueConstraint(fields=('subsidiary', 'abbreviation'), name='Two services cannot share the same abbreviation and subsidiary'),
        ),
        migrations.AddConstraint(
            model_name='company',
            constraint=models.UniqueConstraint(fields=('company_group', 'name'), name='Two companies cannot share the same name and the same group.'),
        ),
        migrations.AddConstraint(
            model_name='company',
            constraint=models.UniqueConstraint(fields=('company_group', 'abbreviation'), name='Two companies cannot share the same abbreviation and group'),
        ),
    ]
